<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Flex
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Twilio\Rest\FlexApi\V1;

use Twilio\Exceptions\TwilioException;
use Twilio\ListResource;
use Twilio\Options;
use Twilio\Values;
use Twilio\Version;


class InsightsQuestionnairesCategoryList extends ListResource
    {
    /**
     * Construct the InsightsQuestionnairesCategoryList
     *
     * @param Version $version Version that contains the resource
     */
    public function __construct(
        Version $version
    ) {
        parent::__construct($version);

        // Path Solution
        $this->solution = [
        ];

        $this->uri = '/Insights/QM/Categories';
    }

    /**
     * Create the InsightsQuestionnairesCategoryInstance
     *
     * @param string $name The name of this category.
     * @param array|Options $options Optional Arguments
     * @return InsightsQuestionnairesCategoryInstance Created InsightsQuestionnairesCategoryInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function create(string $name, array $options = []): InsightsQuestionnairesCategoryInstance
    {

        $options = new Values($options);

        $data = Values::of([
            'Name' =>
                $name,
        ]);

        $headers = Values::of(['Token' => $options['token']]);

        $payload = $this->version->create('POST', $this->uri, [], $data, $headers);

        return new InsightsQuestionnairesCategoryInstance(
            $this->version,
            $payload
        );
    }


    /**
     * Constructs a InsightsQuestionnairesCategoryContext
     *
     * @param string $categoryId The ID of the category to be deleted
     */
    public function getContext(
        string $categoryId
        
    ): InsightsQuestionnairesCategoryContext
    {
        return new InsightsQuestionnairesCategoryContext(
            $this->version,
            $categoryId
        );
    }

    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString(): string
    {
        return '[Twilio.FlexApi.V1.InsightsQuestionnairesCategoryList]';
    }
}
