<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Flex
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Twilio\Rest\FlexApi\V1;

use Twilio\Exceptions\TwilioException;
use Twilio\ListResource;
use Twilio\Options;
use Twilio\Values;
use Twilio\Version;
use Twilio\Serialize;


class InsightsQuestionnairesQuestionList extends ListResource
    {
    /**
     * Construct the InsightsQuestionnairesQuestionList
     *
     * @param Version $version Version that contains the resource
     */
    public function __construct(
        Version $version
    ) {
        parent::__construct($version);

        // Path Solution
        $this->solution = [
        ];

        $this->uri = '/Insights/QM/Questions';
    }

    /**
     * Create the InsightsQuestionnairesQuestionInstance
     *
     * @param string $categoryId The ID of the category
     * @param string $question The question.
     * @param string $description The description for the question.
     * @param string $answerSetId The answer_set for the question.
     * @param bool $allowNa The flag to enable for disable NA for answer.
     * @param array|Options $options Optional Arguments
     * @return InsightsQuestionnairesQuestionInstance Created InsightsQuestionnairesQuestionInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function create(string $categoryId, string $question, string $description, string $answerSetId, bool $allowNa, array $options = []): InsightsQuestionnairesQuestionInstance
    {

        $options = new Values($options);

        $data = Values::of([
            'CategoryId' =>
                $categoryId,
            'Question' =>
                $question,
            'Description' =>
                $description,
            'AnswerSetId' =>
                $answerSetId,
            'AllowNa' =>
                Serialize::booleanToString($allowNa),
        ]);

        $headers = Values::of(['Token' => $options['token']]);

        $payload = $this->version->create('POST', $this->uri, [], $data, $headers);

        return new InsightsQuestionnairesQuestionInstance(
            $this->version,
            $payload
        );
    }


    /**
     * Constructs a InsightsQuestionnairesQuestionContext
     *
     * @param string $questionId The unique ID of the question
     */
    public function getContext(
        string $questionId
        
    ): InsightsQuestionnairesQuestionContext
    {
        return new InsightsQuestionnairesQuestionContext(
            $this->version,
            $questionId
        );
    }

    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString(): string
    {
        return '[Twilio.FlexApi.V1.InsightsQuestionnairesQuestionList]';
    }
}
